package io.modules.sys.controller;


import io.common.constant.Constant;
import io.common.page.PageData;
import io.common.utils.Result;
import io.common.validator.AssertUtils;
import io.common.validator.ValidatorUtils;
import io.common.validator.group.AddGroup;
import io.common.validator.group.DefaultGroup;
import io.common.validator.group.UpdateGroup;
import io.modules.item.dto.TopicDTO;
import io.modules.item.service.TopicService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;


/**
 * 健康资讯
 *
 * @author Mark #
 * @since 1.0.0 2025-02-18
 */
@RestController
@RequestMapping("sys/topic")
@Tag(name="健康资讯")
@CrossOrigin
public class TopicController {

    @Autowired
    private TopicService topicService;

    @GetMapping("page")
    @Operation(summary = "分页")
    @Parameters({
        @Parameter(name = Constant.PAGE, description = "当前页码，从1开始", in = ParameterIn.QUERY, required = true, ref="int") ,
        @Parameter(name = Constant.LIMIT, description = "每页显示记录数", in = ParameterIn.QUERY,required = true, ref="int") ,
        @Parameter(name = Constant.ORDER_FIELD, description = "排序字段", in = ParameterIn.QUERY, ref="String") ,
        @Parameter(name = Constant.ORDER, description = "排序方式，可选值(asc、desc)", in = ParameterIn.QUERY, ref="String")
    })
    public Result<PageData<TopicDTO>> page(@Parameter(hidden = true) @RequestParam Map<String, Object> params){
        PageData<TopicDTO> page = topicService.page(params);

        return new Result<PageData<TopicDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @Operation(summary = "信息")

    public Result<TopicDTO> get(@PathVariable("id") Long id){
        TopicDTO data = topicService.get(id);

        return new Result<TopicDTO>().ok(data);
    }

    @PostMapping
    @Operation(summary = "保存")

    public Result save(@RequestBody TopicDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);

        topicService.save(dto);

        return new Result();
    }

    @PutMapping
    @Operation(summary = "修改")

    public Result update(@RequestBody TopicDTO dto){
        //效验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        topicService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @Operation(summary = "删除")

    public Result delete(@RequestBody Long[] ids){
        //效验数据
        AssertUtils.isArrayEmpty(ids, "id");

        topicService.delete(ids);

        return new Result();
    }


}
